local f = InfoPanel.AddPlugin();
local sessionStart = GetTime();
local startMoney;

--------------------------------------------------------------------------------------------------------
--                                             Functions                                              --
--------------------------------------------------------------------------------------------------------

-- OnEnter
local function OnEnter(self)
	self:MakeTip("Money Info");

	local money = GetMoney();
	GameTooltip:AddDoubleLine("Initial Money",InfoPanel.FormatCopper(startMoney));
	if (money ~= startMoney) then
		local text = (money > startMoney) and "Gained" or "Lost";
		local moneyPerHour = (money - startMoney) / ((GetTime() - sessionStart) / 60 / 60);
		GameTooltip:AddDoubleLine("Money "..text,InfoPanel.FormatCopper(abs(money - startMoney)));
		GameTooltip:AddDoubleLine("Money "..text.." / Hour",InfoPanel.FormatCopper(floor(abs(moneyPerHour))));
	end

	GameTooltip:Show();
end

-- OnClick
local function OnClick(self,button)
	if (ChatFrameEditBox:IsShown()) then
		ChatFrameEditBox:Insert(f.text:GetText():gsub("|c%x%x%x%x%x%x%x%x",""):gsub("|r",""));
	elseif (IsShiftKeyDown()) and (button == "RightButton") then
		sessionStart = GetTime();
		startMoney = GetMoney();
		OnEnter(self);
	end
end

-- Money Change
function f:PLAYER_MONEY(event)
	local money = floor(GetMoney());
	local copper = (money % 100);
	local silver = floor(money % 10000 / 100);
	local gold = floor(money / 10000);
	self:SetText(GOLD_AMOUNT_TEXTURE.." "..SILVER_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE,gold,16,16,silver,16,16,copper,16,16);
--	self:SetText(format(GOLD_AMOUNT_TEXTURE,gold,16,16).." "..format(SILVER_AMOUNT_TEXTURE,silver,16,16).." "..format(COPPER_AMOUNT_TEXTURE,copper,16,16));
--	self:SetText(InfoPanel.FormatCopper(GetMoney()));
end

-- Login
function f:PLAYER_LOGIN(self,event)
	startMoney = GetMoney();
	f:UnregisterAllEvents();
	f:RegisterEvent("PLAYER_MONEY");
	f.PLAYER_LOGIN = nil;
	f:PLAYER_MONEY();
end

--------------------------------------------------------------------------------------------------------
--                                              Finalize                                              --
--------------------------------------------------------------------------------------------------------

f.icon:SetTexture("Interface\\Icons\\INV_Misc_Coin_01");
f:SetScript("OnEnter",OnEnter);
f:SetScript("OnClick",OnClick);
f:RegisterEvent("PLAYER_LOGIN");